#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
# generated by wxGlade 1.0.0a8
#

import wx
import wx.lib.intctrl
import os
import pickle
from settings import FILE_SETTINGS
import logging.config

logger = logging.getLogger(__name__)


class FixerSettings(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = kwds.get("style", 0) | wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.SetSize((340, 258))
        self.SetTitle("Fixer Settings")
        _icon = wx.NullIcon
        _icon.CopyFromBitmap(
            wx.Bitmap(
                os.path.join("resources", "icons", "tool.ico"),
                wx.BITMAP_TYPE_ANY,
            )
        )
        self.SetIcon(_icon)

        sizer_1 = wx.BoxSizer(wx.VERTICAL)

        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(sizer_3, 0, wx.EXPAND|wx.TOP|wx.LEFT, 5)

        self.cbx_8 = wx.CheckBox(self, wx.ID_ANY, "Popravi gapove na:  ")
        self.cbx_8.SetMinSize((140, 15))
        sizer_3.Add(
            self.cbx_8, 0, wx.ALIGN_CENTER_VERTICAL | wx.RIGHT | wx.TOP, 5
        )
        sizer_3.Add((18, 18), 0, 0, 0)

        self.mingap = wx.lib.intctrl.IntCtrl(self, size=(50, -1))
        sizer_3.Add(self.mingap, 0, wx.ALIGN_CENTER_VERTICAL | wx.LEFT, 3)

        self.label_1 = wx.StaticText(self, wx.ID_ANY, "(ms)")
        sizer_3.Add(self.label_1, 0, wx.ALIGN_CENTER_VERTICAL | wx.LEFT|wx.RIGHT, 5)
        
        sizer_3.Add((64, 20), 0, 0, 0)

        self.cbx_7 = wx.CheckBox(
            self, wx.ID_ANY, "Poravnaj linije teksta", style=wx.CHK_2STATE
        )
        self.cbx_7.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_7, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_6 = wx.CheckBox(
            self, wx.ID_ANY, u"Crtice na početku prvog reda", style=wx.CHK_2STATE
        )
        self.cbx_6.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_6, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_5 = wx.CheckBox(
            self, wx.ID_ANY, u"Spejs iza crtice na početku", style=wx.CHK_2STATE
        )
        self.cbx_5.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_5, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_4 = wx.CheckBox(
            self, wx.ID_ANY, u"Suvišni spejsevi", style=wx.CHK_2STATE
        )
        self.cbx_4.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_4, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_3 = wx.CheckBox(
            self, wx.ID_ANY, u"Suvišni italik tagovi", style=wx.CHK_2STATE
        )
        self.cbx_3.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_3, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_2 = wx.CheckBox(
            self, wx.ID_ANY, "Brisanje kolor tagova u titlu", style=wx.CHK_2STATE
        )
        self.cbx_2.SetMinSize((46, 15))
        sizer_1.Add(self.cbx_2, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)

        self.cbx_1 = wx.CheckBox(
            self, wx.ID_ANY, "Nuliranje vremena celog titla", style=wx.CHK_2STATE
        )
        self.cbx_1.SetForegroundColour(wx.Colour(255, 0, 0))
        self.cbx_1.SetToolTip("\n Carefully, think twice :-)\n \n")
        sizer_1.Add(self.cbx_1, 0, wx.EXPAND | wx.LEFT | wx.TOP, 5)
        
        t1 = os.path.join('resources', 'var', 'dialog_settings.db.dat')
        ## cbx_8=GAP, cbx7=Poravnaj linie, cbx_6=Crtice na početku, cbx_5=Spejs iza crtice,
        ## cbx_4=Suvišni spejsevi, cbx_3=Suvišni italik tagovi, cbx_2=Kolor tagovi, cbx_1=Nuliranje
        if os.path.exists(t1):
            try:
                with open(
                    os.path.join('resources', 'var', 'dialog_settings.db.dat'), "rb"
                ) as sp: data = pickle.load(sp)
                ex = data['key1']
            except Exception as e:
                logger.debug(f"fixerSetting error: {e}")
            else:
                self.cbx_1.SetValue(ex["nuliranje"])
                self.cbx_2.SetValue(ex["kolor"])
                self.cbx_3.SetValue(ex["italik"])
                self.cbx_4.SetValue(ex["spejsevi"])
                self.cbx_5.SetValue(ex["crtice_sp"])
                self.cbx_6.SetValue(ex["crtice"])
                self.cbx_7.SetValue(ex["linije"])
                self.cbx_8.SetValue(ex["fixgap"])
                self.mingap.SetValue(ex["mingap"])

            for i in [self.cbx_8, self.mingap, self.label_1]:
                if self.cbx_1.IsChecked(): i.Disable()
                    
        static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        sizer_1.Add(static_line_1, 0, wx.EXPAND | wx.LEFT | wx.RIGHT | wx.TOP, 5)

        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(sizer_2, 0, wx.ALIGN_RIGHT | wx.ALL, 4)

        self.button_OK = wx.Button(self, wx.ID_OK, "")
        self.button_OK.SetMinSize((70, 22))
        self.button_OK.SetDefault()
        sizer_2.Add(self.button_OK, 0, 0, 0)

        self.button_CANCEL = wx.Button(self, wx.ID_CANCEL, "")
        self.button_CANCEL.SetMinSize((70, 22))
        sizer_2.Add(self.button_CANCEL, 0, 0, 0)

        self.SetSizer(sizer_1)
        sizer_1.SetSizeHints(self)

        self.SetAffirmativeId(self.button_OK.GetId())
        self.SetEscapeId(self.button_CANCEL.GetId())

        self.Layout()

        self.Bind(wx.EVT_TOOL, self.onClose, id=-1)
        self.Bind(wx.EVT_BUTTON, self.on_ok, self.button_OK)
        self.Bind(wx.EVT_BUTTON, self.on_cancel, self.button_CANCEL)
        self.Bind(wx.EVT_CHECKBOX, self.EvtChBox, self.cbx_1)
        # end wxGlade

    def EvtChBox(self, event):
        """"""
        for i in [self.cbx_8, self.mingap, self.label_1]:
            if self.cbx_1.IsChecked():
                i.Disable()
            else: i.Enable()
        event.Skip()
    
    def on_cancel(self, event):
        self.Destroy()
        event.Skip()

    def on_ok(self, event):
        ''''''
        ## cbx_8=GAP, cbx7=Poravnaj linie, cbx_6=Crtice na početku, cbx_5=Spejs iza crtice,
        ## cbx_4=Suvišni spejsevicbx_3=Suvišni italik tagovi, cbx_2=Kolor tagovi, cbx_1=Nuliranje
        sdict = {
            'nuliranje': self.cbx_1.GetValue(),
            'kolor': self.cbx_2.GetValue(),
            'italik': self.cbx_3.GetValue(),
            'spejsevi': self.cbx_4.GetValue(),
            'crtice_sp': self.cbx_5.GetValue(),
            'crtice': self.cbx_6.GetValue(),
            'linije': self.cbx_7.GetValue(),
            'fixgap': self.cbx_8.GetValue(),
            'mingap': self.mingap.GetValue(),
        }

        FILE_SETTINGS["key1"] = sdict

        with open(
            os.path.join('resources', 'var', 'dialog_settings.db.dat'), "wb"
        ) as s:
            pickle.dump(FILE_SETTINGS, s)

        self.EndModal(True)

    def onClose(self, event):
        self.Destroy()
        event.Skip()


class MyApp(wx.App):
    def OnInit(self):
        self.dialog = FixerSettings(None, wx.ID_ANY, "")
        self.SetTopWindow(self.dialog)
        self.dialog.ShowModal()
        self.dialog.Destroy()
        return True


# end of class MyApp

if __name__ == "__main__":
    app = MyApp(0)
    app.MainLoop()
